Index: uspace/lib/ui/test/window.c
===================================================================
--- uspace/lib/ui/test/window.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/test/window.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -45,12 +45,20 @@
 PCUT_TEST_SUITE(window);
 
+static void test_window_sysmenu(ui_window_t *, void *, sysarg_t);
+static void test_window_minimize(ui_window_t *, void *);
+static void test_window_maximize(ui_window_t *, void *);
+static void test_window_unmaximize(ui_window_t *, void *);
 static void test_window_close(ui_window_t *, void *);
-static void test_window_focus(ui_window_t *, void *);
+static void test_window_focus(ui_window_t *, void *, unsigned);
 static void test_window_kbd(ui_window_t *, void *, kbd_event_t *);
 static errno_t test_window_paint(ui_window_t *, void *);
 static void test_window_pos(ui_window_t *, void *, pos_event_t *);
-static void test_window_unfocus(ui_window_t *, void *);
+static void test_window_unfocus(ui_window_t *, void *, unsigned);
 
 static ui_window_cb_t test_window_cb = {
+	.sysmenu = test_window_sysmenu,
+	.minimize = test_window_minimize,
+	.maximize = test_window_maximize,
+	.unmaximize = test_window_unmaximize,
 	.close = test_window_close,
 	.focus = test_window_focus,
@@ -66,5 +74,5 @@
 static errno_t test_ctl_paint(void *);
 static ui_evclaim_t test_ctl_pos_event(void *, pos_event_t *);
-static void test_ctl_unfocus(void *);
+static void test_ctl_unfocus(void *, unsigned);
 
 static ui_control_ops_t test_ctl_ops = {
@@ -76,6 +84,12 @@
 typedef struct {
 	errno_t rc;
+	bool sysmenu;
+	sysarg_t sysmenu_idev_id;
+	bool minimize;
+	bool maximize;
+	bool unmaximize;
 	bool close;
 	bool focus;
+	unsigned focus_nfocus;
 	bool kbd;
 	kbd_event_t kbd_event;
@@ -84,4 +98,5 @@
 	pos_event_t pos_event;
 	bool unfocus;
+	unsigned unfocus_nfocus;
 } test_cb_resp_t;
 
@@ -93,4 +108,5 @@
 	pos_event_t pos_event;
 	bool unfocus;
+	unsigned unfocus_nfocus;
 } test_ctl_resp_t;
 
@@ -521,9 +537,156 @@
 	resp.unfocus = false;
 
-	ui_window_def_unfocus(window);
+	ui_window_def_unfocus(window, 42);
 	PCUT_ASSERT_TRUE(resp.unfocus);
+	PCUT_ASSERT_INT_EQUALS(42, resp.unfocus_nfocus);
 
 	/* Need to remove first because we didn't implement the destructor */
 	ui_window_remove(window, control);
+
+	ui_window_destroy(window);
+	ui_destroy(ui);
+}
+
+/** ui_window_send_sysmenu() calls sysmenu callback set via ui_window_set_cb() */
+PCUT_TEST(send_sysmenu)
+{
+	errno_t rc;
+	ui_t *ui = NULL;
+	ui_wnd_params_t params;
+	ui_window_t *window = NULL;
+	test_cb_resp_t resp;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_wnd_params_init(&params);
+	params.caption = "Hello";
+
+	rc = ui_window_create(ui, &params, &window);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(window);
+
+	/* Sysmenu callback with no callbacks set */
+	ui_window_send_sysmenu(window, 42);
+
+	/* Sysmenu callback with sysmenu callback not implemented */
+	ui_window_set_cb(window, &dummy_window_cb, NULL);
+	ui_window_send_sysmenu(window, 42);
+
+	/* Sysmenu callback with real callback set */
+	resp.sysmenu = false;
+	resp.sysmenu_idev_id = 0;
+	ui_window_set_cb(window, &test_window_cb, &resp);
+	ui_window_send_sysmenu(window, 42);
+	PCUT_ASSERT_TRUE(resp.sysmenu);
+	PCUT_ASSERT_INT_EQUALS(42, resp.sysmenu_idev_id);
+
+	ui_window_destroy(window);
+	ui_destroy(ui);
+}
+
+/** ui_window_send_minimize() calls minimize callback set via ui_window_set_cb() */
+PCUT_TEST(send_minimize)
+{
+	errno_t rc;
+	ui_t *ui = NULL;
+	ui_wnd_params_t params;
+	ui_window_t *window = NULL;
+	test_cb_resp_t resp;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_wnd_params_init(&params);
+	params.caption = "Hello";
+
+	rc = ui_window_create(ui, &params, &window);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(window);
+
+	/* Minimize callback with no callbacks set */
+	ui_window_send_minimize(window);
+
+	/* Minimize callback with minimize callback not implemented */
+	ui_window_set_cb(window, &dummy_window_cb, NULL);
+	ui_window_send_minimize(window);
+
+	/* Minimize callback with real callback set */
+	resp.minimize = false;
+	ui_window_set_cb(window, &test_window_cb, &resp);
+	ui_window_send_minimize(window);
+	PCUT_ASSERT_TRUE(resp.minimize);
+
+	ui_window_destroy(window);
+	ui_destroy(ui);
+}
+
+/** ui_window_send_maximize() calls maximize callback set via ui_window_set_cb() */
+PCUT_TEST(send_maximize)
+{
+	errno_t rc;
+	ui_t *ui = NULL;
+	ui_wnd_params_t params;
+	ui_window_t *window = NULL;
+	test_cb_resp_t resp;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_wnd_params_init(&params);
+	params.caption = "Hello";
+
+	rc = ui_window_create(ui, &params, &window);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(window);
+
+	/* Maximize callback with no callbacks set */
+	ui_window_send_maximize(window);
+
+	/* Maximize callback with maximize callback not implemented */
+	ui_window_set_cb(window, &dummy_window_cb, NULL);
+	ui_window_send_maximize(window);
+
+	/* Maximize callback with real callback set */
+	resp.maximize = false;
+	ui_window_set_cb(window, &test_window_cb, &resp);
+	ui_window_send_maximize(window);
+	PCUT_ASSERT_TRUE(resp.maximize);
+
+	ui_window_destroy(window);
+	ui_destroy(ui);
+}
+
+/** ui_window_send_unmaximize() calls unmaximize callback set via ui_window_set_cb() */
+PCUT_TEST(send_unmaximize)
+{
+	errno_t rc;
+	ui_t *ui = NULL;
+	ui_wnd_params_t params;
+	ui_window_t *window = NULL;
+	test_cb_resp_t resp;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_wnd_params_init(&params);
+	params.caption = "Hello";
+
+	rc = ui_window_create(ui, &params, &window);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(window);
+
+	/* Unmaximize callback with no callbacks set */
+	ui_window_send_unmaximize(window);
+
+	/* Unmaximize callback with unmaximize callback not implemented */
+	ui_window_set_cb(window, &dummy_window_cb, NULL);
+	ui_window_send_unmaximize(window);
+
+	/* Unmaximize callback with real callback set */
+	resp.unmaximize = false;
+	ui_window_set_cb(window, &test_window_cb, &resp);
+	ui_window_send_unmaximize(window);
+	PCUT_ASSERT_TRUE(resp.unmaximize);
 
 	ui_window_destroy(window);
@@ -587,15 +750,16 @@
 
 	/* Focus callback with no callbacks set */
-	ui_window_send_focus(window);
+	ui_window_send_focus(window, 42);
 
 	/* Focus callback with focus callback not implemented */
 	ui_window_set_cb(window, &dummy_window_cb, NULL);
-	ui_window_send_focus(window);
+	ui_window_send_focus(window, 42);
 
 	/* Focus callback with real callback set */
 	resp.focus = false;
 	ui_window_set_cb(window, &test_window_cb, &resp);
-	ui_window_send_focus(window);
+	ui_window_send_focus(window, 42);
 	PCUT_ASSERT_TRUE(resp.focus);
+	PCUT_ASSERT_INT_EQUALS(42, resp.focus_nfocus);
 
 	ui_window_destroy(window);
@@ -623,5 +787,5 @@
 	PCUT_ASSERT_NOT_NULL(window);
 
-	kbd_event.type = POS_PRESS;
+	kbd_event.type = KEY_PRESS;
 	kbd_event.key = KC_X;
 	kbd_event.mods = 0;
@@ -755,18 +919,48 @@
 
 	/* Unfocus callback with no callbacks set */
-	ui_window_send_unfocus(window);
+	ui_window_send_unfocus(window, 42);
 
 	/* Unfocus callback with unfocus callback not implemented */
 	ui_window_set_cb(window, &dummy_window_cb, NULL);
-	ui_window_send_unfocus(window);
+	ui_window_send_unfocus(window, 42);
 
 	/* Unfocus callback with real callback set */
 	resp.close = false;
 	ui_window_set_cb(window, &test_window_cb, &resp);
-	ui_window_send_unfocus(window);
+	ui_window_send_unfocus(window, 42);
 	PCUT_ASSERT_TRUE(resp.unfocus);
-
-	ui_window_destroy(window);
-	ui_destroy(ui);
+	PCUT_ASSERT_INT_EQUALS(42, resp.unfocus_nfocus);
+
+	ui_window_destroy(window);
+	ui_destroy(ui);
+}
+
+static void test_window_sysmenu(ui_window_t *window, void *arg, sysarg_t idev_id)
+{
+	test_cb_resp_t *resp = (test_cb_resp_t *) arg;
+
+	resp->sysmenu = true;
+	resp->sysmenu_idev_id = idev_id;
+}
+
+static void test_window_minimize(ui_window_t *window, void *arg)
+{
+	test_cb_resp_t *resp = (test_cb_resp_t *) arg;
+
+	resp->minimize = true;
+}
+
+static void test_window_maximize(ui_window_t *window, void *arg)
+{
+	test_cb_resp_t *resp = (test_cb_resp_t *) arg;
+
+	resp->maximize = true;
+}
+
+static void test_window_unmaximize(ui_window_t *window, void *arg)
+{
+	test_cb_resp_t *resp = (test_cb_resp_t *) arg;
+
+	resp->unmaximize = true;
 }
 
@@ -778,9 +972,10 @@
 }
 
-static void test_window_focus(ui_window_t *window, void *arg)
+static void test_window_focus(ui_window_t *window, void *arg, unsigned nfocus)
 {
 	test_cb_resp_t *resp = (test_cb_resp_t *) arg;
 
 	resp->focus = true;
+	resp->focus_nfocus = nfocus;
 }
 
@@ -811,9 +1006,10 @@
 }
 
-static void test_window_unfocus(ui_window_t *window, void *arg)
+static void test_window_unfocus(ui_window_t *window, void *arg, unsigned nfocus)
 {
 	test_cb_resp_t *resp = (test_cb_resp_t *) arg;
 
 	resp->unfocus = true;
+	resp->unfocus_nfocus = nfocus;
 }
 
@@ -836,9 +1032,10 @@
 }
 
-static void test_ctl_unfocus(void *arg)
+static void test_ctl_unfocus(void *arg, unsigned nfocus)
 {
 	test_ctl_resp_t *resp = (test_ctl_resp_t *) arg;
 
 	resp->unfocus = true;
+	resp->unfocus_nfocus = nfocus;
 }
 
Index: uspace/lib/usbdev/include/usb/dev/device.h
===================================================================
--- uspace/lib/usbdev/include/usb/dev/device.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/usbdev/include/usb/dev/device.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -91,5 +91,5 @@
 
 usb_address_t usb_device_get_address(const usb_device_t *);
-usb_speed_t usb_device_get_depth(const usb_device_t *);
+unsigned usb_device_get_depth(const usb_device_t *);
 usb_speed_t usb_device_get_speed(const usb_device_t *);
 int usb_device_get_iface_number(const usb_device_t *);
Index: uspace/lib/usbhid/src/hidparser.c
===================================================================
--- uspace/lib/usbhid/src/hidparser.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/usbhid/src/hidparser.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -225,5 +225,5 @@
 	/* Than we take the higher bits from the LSB */
 	const unsigned bit_offset = item->offset % 8;
-	const int lsb_bits = min(bits, 8);
+	const int lsb_bits = min((unsigned)bits, 8 - bit_offset);
 
 	value |= (*data >> bit_offset) & BIT_RRANGE(uint8_t, lsb_bits);
Index: uspace/lib/usbhost/src/hcd.c
===================================================================
--- uspace/lib/usbhost/src/hcd.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/usbhost/src/hcd.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -95,9 +95,11 @@
  * TODO: Make the bus mechanism less flexible in irq handling and remove the
  * lookup.
- */
-static void irq_handler(ipc_call_t *call, ddf_dev_t *dev)
-{
-	assert(dev);
-	hc_device_t *hcd = dev_to_hcd(dev);
+ *
+ * @param call Interrupt notification
+ * @param arg Argument (hc_device_t *)
+ */
+static void irq_handler(ipc_call_t *call, void *arg)
+{
+	hc_device_t *hcd = (hc_device_t *)arg;
 
 	const uint32_t status = ipc_get_arg1(call);
@@ -178,5 +180,5 @@
 	cap_irq_handle_t ihandle;
 	ret = register_interrupt_handler(hcd->ddf_dev, irq, irq_handler,
-	    &irq_code, &ihandle);
+	    (void *)hcd, &irq_code, &ihandle);
 	irq_code_clean(&irq_code);
 	if (ret != EOK) {
Index: uspace/lib/usbvirt/src/ipc_dev.c
===================================================================
--- uspace/lib/usbvirt/src/ipc_dev.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/usbvirt/src/ipc_dev.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2023 Jiri Svoboda
  * Copyright (c) 2011 Vojtech Horky
  * All rights reserved.
@@ -59,4 +60,5 @@
 	size_t accepted_size;
 	if (!async_data_read_receive(&call, &accepted_size)) {
+		async_answer_0(&call, EINVAL);
 		async_answer_0(icall, EINVAL);
 		return;
@@ -94,4 +96,5 @@
 	ipc_call_t data;
 	if (!async_data_read_receive(&data, &data_len)) {
+		async_answer_0(&data, EPARTY);
 		async_answer_0(icall, EPARTY);
 		free(setup_packet);
@@ -101,4 +104,5 @@
 	void *buffer = malloc(data_len);
 	if (buffer == NULL) {
+		async_answer_0(&data, EPARTY);
 		async_answer_0(icall, ENOMEM);
 		free(setup_packet);
@@ -184,4 +188,5 @@
 	ipc_call_t data;
 	if (!async_data_read_receive(&data, &data_len)) {
+		async_answer_0(&data, EPARTY);
 		async_answer_0(icall, EPARTY);
 		return;
@@ -190,4 +195,5 @@
 	void *buffer = malloc(data_len);
 	if (buffer == NULL) {
+		async_answer_0(&data, EPARTY);
 		async_answer_0(icall, ENOMEM);
 		return;
Index: uspace/lib/wndmgt/doc/doxygroups.h
===================================================================
--- uspace/lib/wndmgt/doc/doxygroups.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/wndmgt/doc/doxygroups.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,3 @@
+/** @addtogroup libwndmgt libwndmgt
+ * @ingroup libs
+ */
Index: uspace/lib/wndmgt/include/ipc/wndmgt.h
===================================================================
--- uspace/lib/wndmgt/include/ipc/wndmgt.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/wndmgt/include/ipc/wndmgt.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,56 @@
+/*
+ * Copyright (c) 2022 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libwndmgt
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBWNDMGT_IPC_WNDMGT_H
+#define LIBWNDMGT_IPC_WNDMGT_H
+
+#include <ipc/common.h>
+
+typedef enum {
+	WNDMGT_CALLBACK_CREATE = IPC_FIRST_USER_METHOD,
+	WNDMGT_GET_WINDOW_LIST,
+	WNDMGT_GET_WINDOW_INFO,
+	WNDMGT_ACTIVATE_WINDOW,
+	WNDMGT_CLOSE_WINDOW,
+	WNDMGT_GET_EVENT,
+} wndmgt_request_t;
+
+typedef enum {
+	WNDMGT_EV_PENDING = IPC_FIRST_USER_METHOD
+} wndmgt_event_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/wndmgt/include/types/wndmgt.h
===================================================================
--- uspace/lib/wndmgt/include/types/wndmgt.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/wndmgt/include/types/wndmgt.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,98 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libwndmgt
+ * @{
+ */
+/** @file
+ */
+
+#ifndef _LIBWNDMGT_TYPES_WNDMGT_H_
+#define _LIBWNDMGT_TYPES_WNDMGT_H_
+
+#include <ipc/services.h>
+#include <types/common.h>
+
+/** Use the default window management service (argument to wndmgt_open() */
+#define WNDMGT_DEFAULT SERVICE_NAME_WNDMGT
+
+struct wndmgt;
+
+/** Window management session */
+typedef struct wndmgt wndmgt_t;
+
+/** Window management callbacks */
+typedef struct {
+	/** Window added */
+	void (*window_added)(void *, sysarg_t);
+	/** Window removed */
+	void (*window_removed)(void *, sysarg_t);
+	/** Window changed */
+	void (*window_changed)(void *, sysarg_t);
+} wndmgt_cb_t;
+
+/** Window management event type */
+typedef enum {
+	/** Window added */
+	wmev_window_added,
+	/** Window removed */
+	wmev_window_removed,
+	/** Window changed */
+	wmev_window_changed
+} wndmgt_ev_type_t;
+
+/** Window management event */
+typedef struct {
+	/** Event type */
+	wndmgt_ev_type_t etype;
+	/** Window ID */
+	sysarg_t wnd_id;
+} wndmgt_ev_t;
+
+/** Window list */
+typedef struct {
+	/** Number of windows */
+	size_t nwindows;
+	/** ID for each window */
+	sysarg_t *windows;
+} wndmgt_window_list_t;
+
+/** Window information */
+typedef struct {
+	/** Window caption */
+	char *caption;
+	/** Window flags */
+	unsigned flags;
+	/** Number of foci on this window */
+	unsigned nfocus;
+} wndmgt_window_info_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/wndmgt/include/wndmgt.h
===================================================================
--- uspace/lib/wndmgt/include/wndmgt.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/wndmgt/include/wndmgt.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,55 @@
+/*
+ * Copyright (c) 2022 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libwndmgt
+ * @{
+ */
+/** @file
+ */
+
+#ifndef _LIBWNDMGT_WNDMGT_H_
+#define _LIBWNDMGT_WNDMGT_H_
+
+#include <errno.h>
+#include <types/common.h>
+#include "types/wndmgt.h"
+
+extern errno_t wndmgt_open(const char *, wndmgt_cb_t *, void *, wndmgt_t **);
+extern void wndmgt_close(wndmgt_t *);
+extern errno_t wndmgt_get_window_list(wndmgt_t *, wndmgt_window_list_t **);
+extern void wndmgt_free_window_list(wndmgt_window_list_t *);
+extern errno_t wndmgt_get_window_info(wndmgt_t *, sysarg_t,
+    wndmgt_window_info_t **);
+extern void wndmgt_free_window_info(wndmgt_window_info_t *);
+extern errno_t wndmgt_activate_window(wndmgt_t *, sysarg_t, sysarg_t);
+extern errno_t wndmgt_close_window(wndmgt_t *, sysarg_t);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/wndmgt/include/wndmgt_srv.h
===================================================================
--- uspace/lib/wndmgt/include/wndmgt_srv.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/wndmgt/include/wndmgt_srv.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,66 @@
+/*
+ * Copyright (c) 2022 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libwndmgt
+ * @{
+ */
+/** @file
+ */
+
+#ifndef _LIBWNDMGT_WNDMGT_SRV_H_
+#define _LIBWNDMGT_WNDMGT_SRV_H_
+
+#include <async.h>
+#include <errno.h>
+#include "types/wndmgt.h"
+
+typedef struct wndmgt_ops wndmgt_ops_t;
+
+/** Window management server structure (per client session) */
+typedef struct {
+	async_sess_t *client_sess;
+	wndmgt_ops_t *ops;
+	void *arg;
+} wndmgt_srv_t;
+
+struct wndmgt_ops {
+	errno_t (*get_window_list)(void *, wndmgt_window_list_t **);
+	errno_t (*get_window_info)(void *, sysarg_t, wndmgt_window_info_t **);
+	errno_t (*activate_window)(void *, sysarg_t, sysarg_t);
+	errno_t (*close_window)(void *, sysarg_t);
+	errno_t (*get_event)(void *, wndmgt_ev_t *);
+};
+
+extern void wndmgt_conn(ipc_call_t *, wndmgt_srv_t *);
+extern void wndmgt_srv_initialize(wndmgt_srv_t *);
+extern void wndmgt_srv_ev_pending(wndmgt_srv_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/wndmgt/meson.build
===================================================================
--- uspace/lib/wndmgt/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/wndmgt/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,37 @@
+#
+# Copyright (c) 2022 Jiri Svoboda
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+src = files(
+	'src/wndmgt.c',
+	'src/wndmgt_srv.c',
+)
+
+test_src = files(
+	'test/main.c',
+	'test/wndmgt.c',
+)
Index: uspace/lib/wndmgt/private/wndmgt.h
===================================================================
--- uspace/lib/wndmgt/private/wndmgt.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/wndmgt/private/wndmgt.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,61 @@
+/*
+ * Copyright (c) 2022 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libwndmgt
+ * @{
+ */
+/** @file
+ */
+
+#ifndef _LIBWNDMGT_PRIVATE_WNDMGT_H_
+#define _LIBWNDMGT_PRIVATE_WNDMGT_H_
+
+#include <async.h>
+#include <fibril_synch.h>
+#include <stdbool.h>
+
+/** Window management session structure */
+struct wndmgt {
+	/** Session with window management service */
+	async_sess_t *sess;
+	/** Callbacks */
+	wndmgt_cb_t *cb;
+	/** Calback argument */
+	void *cb_arg;
+	/** Synchronize access to window management object */
+	fibril_mutex_t lock;
+	/** @c true if callback handler terminated */
+	bool cb_done;
+	/** Signalled when cb_done or ev_pending is changed */
+	fibril_condvar_t cv;
+};
+
+#endif
+
+/** @}
+ */
